Subject: bug#12419: Mouse click changes layout

From: Daniel Pfeiffer <[email-masked]>
Date: Tue, 25 Sep 2012 00:20:31 +0200

Hi Martin!

la 09/24/2012 10:17 AM martin rudalics skribis:
> > However my first informatics lesson the professor told us: the most
> > common bug is being off by one.  That is alas still the case with your
> > patch: After C-x 2 the lower window is one row higher than the upper
> > one.  After our little experiment, it's the other way round, with this
> > result:  When letting go of the mouse, I still marked to the line above,
> > which is now in the position of my mouse-down event.  Sounds like an
> > integer division rounding problem, though I don't see such a thing in
> > your patch.  If both windows together have an even number of rows (by
> > resizing the frame) it's fine.
>
> You should get a similar behavior if you have a root window with an odd
> number of lines, split that window via C-x 2, shrink the frame by one
> line, and enlarge it again by one line: The upper window has stolen one
> line from the lower one.  As a matter of fact, this is not an off-by-one
> error but more deeply rooted in the history of Emacs' window handling.
> You can skip the following explanation if you want.
>
>   Beginning with Emacs 24.1, windows have a normal height (a floating
>   point number) which is the fraction of their ideal height wrt to their
>   parent.  When you do C-x 2 the normal height of both emanating windows
>   is 0.5.  However, when the original window has an odd number of lines,
>   I have to give the lower window the one remaining line in order to be
>   consistent with the traditional splitting behavior.  This means that,
>   if the original window has 11 lines, the upper window gets 5 and the
>   lower window gets 6 lines.
>
>   If I now enlarge the parent window to 22 lines, the upper window gets
>   11 (and not 10) lines and the lower window 11 (and not 12 lines).
>   Sizing back the parent to 11 lines should restore the initial state
>   but it doesn't because I resize windows in the "opposite" direction
>   (from top to bottom/from left to right) which preferably gives
>   to/steals from the topmost/leftmost window.
>
> So I have to fix this regardless of the topic we're discussing here.

Good!  Though it wouldn't annoy me so much, if it weren't that it slightly 
breaks your patch.  What is important to me, is that when I click and let go, 
the point is where I initially clicked, and since I didn't move the mouse, I 
don't want to mark anything.

As for going the "opposite" direction, I wonder if it's worth while to keep a 
history of the last n implicitly changed window configurations and try to 
revert to them wherever possible.  Might be huge task admittedly...

A somewhat related annoyance is that scrolling looses the point: scrolling 
back to where you were before, doesn't revert that. Whenever I scroll to 
somewhere, the point should go where it was last visible within those lines, 
if it had been visible there before!  This should be quite straightforward.  
Though with sideways scrolling it might be more tricky...

> > If however I split either of the two windows again (even the top one,
> > which is out of reach of the resizing echo area) the disturbing new
> > before-your-patch behaviour comes back.
>
> I suppose you should try again.  If I split the top window, only the
> bottom window resizes and I can't observe what you observe here. If I
> make a new bottom window instead, the line where `point' appears in that
> window moves to the top of the window and I can observe the behavior.
> However, I don't see any difference wrt Emacs 23 which means I do not
> see a "disturbing new" before-my-patch behavior.  If you nevertheless
> do, please give me a detailed step-by-step scenario I can repeat here.

The "disturbing new" is that (in our C-x 2 scenario) by clicking somewhere, 
the point ends up somewhere else, and without moving the mouse I've marked 
some text.  I'm fairly confident that this is a recent degradation.  (Though I 
don't have an old Emacs to try against to be sure.)  Your patch improved it, 
but not quite fixed it.

> >> The second scenario you sketched is
> [...]
> > The point is moving the mouse over to the i, which causes the 1st
> > scroll, and then letting go, which causes the scrolled region to be
> > marked, plus it causes a 2nd scroll by the same amount.  So the point is
> > now far from the highlighted part.  I guess this comes from a different
> > code location.  Only the user experience feels to me like both cases
> > should be consistent with one another.
>
> OK.  I see something in this regard.  But Emacs 23 seems to behave in
> exactly the same way.  Or do you see a difference?

I don't C-x 3 so much, so this might have been there before – I don't remember 
when it first annoyed me.  Just the occasional glitch, which on its own never 
merited heckling anybody about. Actually sideways scrolling is only neat when 
I click near the edge wanting it.  When I don't think about it, it's usually a 
hassle to get things like they were before.  Probably it should only sideways 
scroll when I drag the mouse over the window edge, like vertical scrolling.

coralament / best Grötens / liebe Grüße / best regards / elkorajn salutojn
Daniel Pfeiffer

-- 
lerne / learn / apprends / lär dig / ucz się    Esperanto:
                     http://lernu.net  /  http://ikurso.net